<template>
    <div>
        <nav class="tab-group-header">
            <ul>
                <li
                    v-for="(tabItem, index) in tabItems"
                    :key="index"
                    class="tab-header"
                    :class="getCustomClasses(index)"
                    @click="tabClick(index)"
                >
                    <a>{{tabItem.label}}</a>
                </li>
            </ul>
        </nav>
        <section class="tabs relative">
            <slot></slot>
        </section>
    </div>
</template>

<script lang='ts'>
import Vue, { VNode } from 'vue'
import Component from 'vue-class-component'
import { Prop } from 'vue-property-decorator'
import TabItem from './TabItem.vue'

@Component({
    name: 'TabGroup',
})
export default class App extends Vue {
    // Props
    @Prop() readonly value: number | undefined

    // Data
    // Internally used to confirm that TabItem is infact an instance of itself
    _isTabGroup = true
    defaultSlots: VNode[] = []
    activeTab: number = this.value || 0

    mounted() {
        if (this.activeTab < this.tabItems.length)
            (this.tabItems[this.activeTab] as TabItem).isActive = true
        this.refreshSlots()
    }

    // Computed
    get tabItems() {
        return this.defaultSlots
            .filter(
                vnode =>
                    vnode.componentInstance &&
                    vnode.componentInstance.$data &&
                    vnode.componentInstance.$data._isTabItem
            )
            .map(vnode => vnode.componentInstance)
    }

    //Methods
    refreshSlots(): void {
        if (this.$slots.default !== undefined) {
            this.defaultSlots = this.$slots.default || []
        }
    }

    getCustomClasses(index: number): { [key: string]: boolean } {
        return {
            active: this.activeTab === index,
        }
    }

    tabClick(index: number): void {
        if (index === this.activeTab) return
        this.changeTab(index)
    }

    changeTab(newIndex: number): void {
        if (
            this.activeTab === newIndex ||
            this.tabItems[newIndex] === undefined
        )
            return

        if (this.activeTab < this.tabItems.length) {
            const vnode = this.tabItems[this.activeTab] as TabItem
            vnode.deactivate(this.activeTab, newIndex)
        }

        const vnode = this.tabItems[newIndex] as TabItem
        vnode.activate(this.activeTab, newIndex)
        this.activeTab = newIndex
    }
}
</script>